//
// ǥˤͷ
//

#include	<cmath>

#include	"nradd.h"
#include	"binarization.h"

// 饤ؿ
static double
sqr(double x)
{
   return x * x;
}

#define	MAXITR	30

// 2Ψ̩ٴؿ
static double
chi2dist(double x, double n)
{
   double       nh, lng, phi;

   nh = n / 2.0;
   lng = gammln(nh);
   phi = exp(-x/2.0) * pow(x, nh-1.0) / (pow(2.0, nh) * exp(lng));

   return phi;
}

// Ψη׻
double
detection_ratio(double p, double q, double sg0, double sg1, double n2)
{
   double	Fa, Fa1;
   double	chi, PHI, phi, phi1;
   double	sgg, qp, oa, alpha, da;
   int		n;

   qp = q / p;
   sgg = sqr(sg0/sg1);

   oa = alpha = 0.5;	// 
   n = 0;

   do
   {
      chi = chiqinvr(1.0 - oa, n2);
      PHI = chipdistr(sgg * chi, n2);
      phi = chi2dist(sgg * chi, n2);
      phi1 = chi2dist(chi, n2);
      Fa = oa - 1.0 + qp * PHI;
      Fa1 = 1.0 + qp * sgg * phi / phi1;
      alpha = oa - Fa / Fa1;
      da = fabs(alpha - oa);
      if (da < 1e-5)
	 break;
      oa = alpha;
      n++;
   }
   while (n < 2*MAXITR);

   return alpha;
}

// ǡϥȤƤΤȤ뢨
// ֤ͤΥǥϼºݤˤϤ -1 ʤФʤʤ
double
etmix_thd1(double x[], int L, int NM, double n2,
	   double muJ, double sgJ2, double pc, double *alpha)
{
   double	sg0, sg1, S0, S1, J0;
   double	isg0, isg1, qprsg0, pqrsg1, nsg0, nsg1;
   double	t0, t1;
   double	p, q;
   double	q0, chi2;
   int		cL;
   int		count;

   // 
   cL = (int)(pc * L + 0.5);

   p = pc * (double)L / (double)NM;
   q = 1.0 - p;

   J0 = 0.0;
   for (int i = 0; i < cL; i++)
      J0 += x[i];
   sg0 = sqrt(J0 / (n2 * cL));
   sg1 = sqrt(sgJ2 / (2.0 * muJ));

   // ѿη׻
   qprsg0 = (q / p) * pow(sg0 / sg1, n2);
   pqrsg1 = (p / q) * pow(sg1 / sg0, n2);
   isg0 = 1.0 / sqr(sg0) - 1.0 / sqr(sg1);
   isg1 = 1.0 / sqr(sg1) - 1.0 / sqr(sg0);

   // ȿ
   count = 0;
   while (count++ < MAX_BIN_ITR)
   {
      S0 = S1 = 0.0;
      for (int i = 0; i < NM; i++)
      {
	 t0 = 1.0 + qprsg0 * exp(x[i] * isg0 / 2.0);
	 t1 = 1.0 + pqrsg1 * exp(x[i] * isg1 / 2.0);
	 S0 += 1.0 / t0;
	 S1 += 1.0 / t1;
      }

      t0 = t1 = 0.0;
      for (int i = 0; i < NM; i++)
      {
	 t0 += x[i] / (1.0 + qprsg0 * exp(x[i] * isg0 / 2.0));
	 t1 += x[i] / (1.0 + pqrsg1 * exp(x[i] * isg1 / 2.0));
      }
      nsg0 = sqrt(t0 / (n2 * S0));
      nsg1 = sqrt(t1 / (n2 * S1));

      if ((fabs(nsg0 - sg0) < MIXEPS) && (fabs(nsg1 - sg1) < MIXEPS))
	 break;

      sg0 = nsg0;
      sg1 = nsg1;
      qprsg0 = (q / p) * pow(sg0 / sg1, n2);
      pqrsg1 = (p / q) * pow(sg1 / sg0, n2);
      isg0 = 1.0 / sqr(sg0) - 1.0 / sqr(sg1);
      isg1 = 1.0 / sqr(sg1) - 1.0 / sqr(sg0);
   }

   *alpha = detection_ratio(p, q, sg0, sg1, n2);
   q0 = 1.0 - (*alpha);
   chi2 = chiqinvr(q0, n2);

   return chi2 * sqr(sg0);
}
