#ifndef	_IMAGE_H_
#define	_IMAGE_H_

// #define      NODEBUG

#include        <cassert>
#include        <cstdlib>

#include	"Harris.h"

// ǥեȤΥ

#define	WIDTH	640
#define	HEIGHT	480

#define	TEMPLATESIZE	7	// 15 x 15 Υƥץ졼
#define	MASK_SIZE	3	// 3 x 3 Υޥ

class	Image
{
  private:
        int	*data;
        int	xlength, ylength;
        int     xc, yc;

  public:
        Image(int xs = WIDTH, int ys = HEIGHT);
        Image(int xmin, int ymin, int xmax, int ymax);
        ~Image();
        void    set_size(int xs, int ys);
	void	set_size(int xmin, int ymin, int xmax, int ymax);
        void    set_center(int xc, int yc);

	int	width() { return xlength; }
	int	height() { return ylength; }
        int     xl() { return xlength; }
        int     yl() { return ylength; }

        int     xcenter() { return xc; }
        int     ycenter() { return yc; }

        int     get_pixel(int x, int y);
        int     get_pixel2(int x, int y);
        double	get_cpixel(double x, double y);
        void    put_pixel(int x, int y, int d);
        void    plot_cross(int x, int y, int len = 5, int data = 255);
        void    plot_im_cross(int x, int y, int len = 5, int data = 255);

        int     get_pixel(int i)
                {
                   return data[i];
                }
        void    put_pixel(int i, int d)
                {
                   data[i] = d;
                }
                   
        int     get_im_pixel(int x, int y)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   return data[y * xlength + x];
                }
        void    put_im_pixel(int x, int y, int d)
                {
		   assert(x >= 0 && x < xlength);
		   assert(y >= 0 && y < ylength);
                   data[y * xlength + x] = d;
                }
        int     get_im_pixel2(int x, int y)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      return data[y * xlength + x];
		   else
		      return -1;
                }
        void    put_im_pixel2(int x, int y, int d)
                {
		   if (   x >= 0 && x < xlength
		       && y >= 0 && y < ylength)
		      data[y * xlength + x] = d;
                }

        void    clear(int data = 0);
        void    trim_size();

        friend void	display(Image& img, char *title);

	friend void	copy_area(Image& src, int u0, int v0,
				  int width, int height, Image& dst);
        friend int	save_pgm_file(Image& img, char *filename);
        friend int      load_pgm_file(Image& img, char *filename);
        friend int	impose_pgm_file(Image& img, char *filename);
        friend int      impose_pgm(Image& im1, Image &im2);
        friend int	Harris(Image &Img,
			       int **up0, int **vp0, int *cnr_num,
			       int Ns, double sigma, double rk,
			       double s, int max_corner, double min_dist);
        friend int	ImpHarris(Image &Img,
                                  int **up0, int **vp0, int *cnr_num,
                                  int Ns, double sigma, double rk,
                                  double s, int max_corner, double min_dist);
};

// ޥ
class	RealMask
{
  private:
	double	*data;
	int	xh, yh;
	int	xs, ys;

  public:
	RealMask(int xs0 = MASK_SIZE, int ys0 = MASK_SIZE)
	   {
	      assert(xs0 % 2 && ys0 % 2);
	      xs = xs0;
	      ys = ys0;
	      data = new double [xs * ys];
	      xh = xs / 2;
	      yh = ys / 2;
	   }
	~RealMask()
	   {
	      delete [] data;
	   }

        int     xsize() { return xs; }
        int     ysize() { return ys; }

        double  get_mask(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return data[(y + yh) * xs + (x + xh)];
                }
        void    put_mask(int x, int y, double d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   data[(y + yh) * xs + (x + xh)] = d;
                }

        void    clear(double d = 0.0)
          	{
		   for (int i = 0; i < (xs * ys); i++)
		      data[i] = d;
		}
};

class	IntMask
{
  private:
	int	*data;
	int	xh, yh;
	int	xs, ys;

  public:
	IntMask(int xs0 = MASK_SIZE, int ys0 = MASK_SIZE)
	   {
	      assert(xs0 % 2 && ys0 % 2);
	      xs = xs0;
	      ys = ys0;
	      data = new int [xs * ys];
	      xh = xs / 2;
	      yh = ys / 2;
	   }
	~IntMask()
	   {
	      delete [] data;
	   }

        int     xsize() { return xs; }
        int     ysize() { return ys; }

        int	get_mask(int x, int y)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   return data[(y + yh) * xs + (x + xh)];
                }
        void    put_mask(int x, int y, int d)
                {
		   assert(abs(x) <= xh || abs(y) <= yh);
                   data[(y + yh) * xs + (x + xh)] = d;
                }

        void    clear(int d = 0)
          	{
		   for (int i = 0; i < (xs * ys); i++)
		      data[i] = d;
		}
};

// ƥץ졼ȼ¿
class	RealTemplate
{
  private:
        double	*data;
        int	x_size, y_size;
        int	xc, yc;
        int	x_min, x_max, y_min, y_max;

  public:
        RealTemplate(int xs = TEMPLATESIZE, int ys = TEMPLATESIZE);
        ~RealTemplate();

	void	resize(int nx, int ny);
        int     xl() { return x_size; }
        int     yl() { return y_size; }
        int     xl2() { return x_max; }
        int     yl2() { return y_max; }
        int     xmin() { return x_min; }
        int     xmax() { return x_max; }
        int     ymin() { return y_min; }
        int     ymax() { return y_max; }

        double  get_pixel(int x, int y);
        void    put_pixel(int x, int y, double d);

        double	get_im_pixel(int u, int v);
        void    put_im_pixel(int u, int v, double d);

        void    clear(double d = 0.0);
};


class	IntTemplate
{
  private:
        int	*data;
        int	x_size, y_size;
        int	xc, yc;
        int	x_min, x_max, y_min, y_max;

  public:
        IntTemplate(int xs = TEMPLATESIZE, int ys = TEMPLATESIZE);
        ~IntTemplate();

	void	resize(int nx, int ny);
        int     xl() { return x_size; }
        int     yl() { return y_size; }
        int     xmin() { return x_min; }
        int     xmax() { return x_max; }
        int     ymin() { return y_min; }
        int     ymax() { return y_max; }

        int	get_pixel(int x, int y);
        void    put_pixel(int x, int y, int d);

        int	get_im_pixel(int u, int v);
        void    put_im_pixel(int u, int v, int d);

        void    clear(int d = 0);
};

void    wait_anykey();

// ƥץ졼Ⱥ
void	set_template(Image& Im, RealTemplate& TP, double xc, double yc);
void	set_template(Image& Im, IntTemplate& TP, double xc, double yc);

// 顼ФФʤ
void	Image_set_quiet();
void	Image_reset_quiet();

#endif	// _IMAGE_H_
