//
// ѴκǾǥˡ
//
//	ּͱѴμư׻(4)
//		2001ǯ312
//


#include	"Mat.h"

#include	"Corresp_cls.h"
#include	"similar.h"
#include	"lmeds.h"

// J_{\lambda}η׻
static double
calc_J_lambda_sim(Complex& Z, double s, Complex& za0, Complex& zb0,
		  Complex& za, Complex& zb)
{
   double	t, J;

   t = abs((zb - zb0) - Z * (za - za0));
   J = t * t / (1 + s * s);

   return J;
}

// Ѵη׻
static void
calc_Sim_lsm(Complex za[], Complex zb[], int idx0, int idx1,
	     Complex& za0, Complex& zb0, Complex& Z, double *s)
{
   Complex	za1, zb1;

   za0 = za[idx0];
   zb0 = zb[idx0];
   za1 = za[idx1];
   zb1 = zb[idx1];

   Z = (zb1 - zb0) / (za1 - za0);
   *s = abs(Z);
}

// ׻줿Ѵ󤫤бФλĺ׻
static double
calc_Sim_med(Complex& Z, double s, Complex& za0, Complex& zb0,
	     Complex za[], Complex zb[], int N, double J0[])
{
   double	t;
   double	J[N];

   // ĺη׻
   for (int i = 0; i < N; i++)
      J0[i] = J[i] = calc_J_lambda_sim(Z, s, za0, zb0, za[i], zb[i]);

   // ˥
   for (int i = 0; i < N - 1; i++)
      for (int j = i + 1; j < N; j++)
      {
	 if (J[i] > J[j])
	 {
	    t = J[j]; J[j] = J[i]; J[i] = t;
	 }
      }

   return J[N/2];
}

// Ǿ᥸ˡˤѴη׻
double
lmeds_sim(Corresp cp[], Complex za[], Complex zb[], double J[], int N,
	  int MaxItr, Complex& Zm0, double *ssm0,
	  Complex& zzm00, Complex& zzm01)
{
   double	S, Sm;
   double	ss, ssm;
   Complex	Z, Zm;
   Complex	za0, zb0;
   Complex	szm0, szm1;
   Complex	zzm0, zzm1;
   int		idx0, idx1;
   int		count, ct;

   // ֤Τν
   Sm = INF;
   szm0 = szm1 = 0.0;
   Zm = 1.0;
   ssm = 1.0;
   count = ct = 0;

   if (N > H_MIN_PTS * 4)
   {
      // бΥڥʬʸĿФǤ: 
      while (count < MaxItr)
      {
	 count++;

	 // 2
	 idx0 = (int)(N * ran1(&idum));
	 while ((idx1 = (int)(N * ran1(&idum))) == idx0);

	 // Ѵη׻
	 calc_Sim_lsm(za, zb, idx0, idx1, za0, zb0, Z, &ss);

	 // бФλĺͤη׻
	 S = calc_Sim_med(Z, ss, za0, zb0, za, zb, N, J);

	 // 
	 if (S < Sm)
	 {
	    Sm = S;
	    Zm = Z;
	    ssm = ss;
	    zzm0 = za0;
	    zzm1 = zb0;
	    ct = 0;
	 }
	 else	// Ϣ³ COUNT_SIM(5) ʾǽλ
	 {	// ȥ饤Ψ: 2䡤ȽΨ 1%ʲ
	    if (++ct >= COUNT_SIM)
	       break;
	 }
      }
   }
   else
   {
      // бΥڥʤ: 
      for (int idx0 = 0; idx0 < N - 1; idx0++)
      {
	 for (int idx1 = idx0 + 1; idx1 < N; idx1++)
	 {
	    // Ѵη׻
	    calc_Sim_lsm(za, zb, idx0, idx1, za0, zb0, Z, &ss);

	    // бФλĺͤη׻
	    S = calc_Sim_med(Z, ss, za0, zb0, za, zb, N, J);

	    // 
	    if (S < Sm)
	    {
	       Sm = S;
	       Zm = Z;
	       ssm = ss;
	       zzm0 = za0;
	       zzm1 = zb0;
	    }
	 }
      }
   }

   Zm0 = Zm;
   *ssm0 = ssm;
   zzm00 = zzm0;
   zzm01 = zzm1;

   return Sm;
}

// ѴκƤϤ
void
recalc_sim(Corresp cp[], Complex za0[], Complex zb0[], double J[], int N,
	   double Sm, Complex& Zm, double ssm, Complex& zzm0, Complex& zzm1,
	   Corresp **ncp, int *Nn, Mat& Rr, VecC& tr, double *ssr)
{
   VecC		*Xa, *Xb;
   int		Nc, k;
   Mat		Hsim;
   double	epsh;
   int		cnt;

   // Ʒ׻˻ȤбФο
   Nc = 0;
   for (int i = 0; i < N; i++)
   {
      J[i] = calc_J_lambda_sim(Zm, ssm, zzm0, zzm1, za0[i], zb0[i]);
      if (J[i] < THD * Sm)
	 Nc++;
   }

   Xa = new VecC [Nc];
   Xb = new VecC [Nc];
   *ncp = new Corresp [Nc];
   *Nn = Nc;

   k = 0;
   for (int i = 0; i < N; i++)
   {
      if (J[i] < THD * Sm)
      {
	 (*ncp)[k].ua = cp[i].ua;
	 (*ncp)[k].va = cp[i].va;
	 (*ncp)[k].ub = cp[i].ub;
	 (*ncp)[k].vb = cp[i].vb;
	 Xa[k][0] = za0[i].real();
	 Xa[k][1] = za0[i].imag();
	 Xa[k][2] = 1.0;
	 Xb[k][0] = zb0[i].real();
	 Xb[k][1] = zb0[i].imag();
	 Xb[k][2] = 1.0;
	 k++;
      }
   }

   // ˥塼ȥˡʤ顤ʲ򥳥ȥ
   //calc_similar(Xa, Xb, (*Nn), 1e-8, 1e-8, 1e-8, 30,
   //             ssr, Rr, tr, &epsh, &cnt);

   // LMˡʤʲͭ
   calc_similarlm(Xa, Xb, (*Nn), 1e-8, 1e-8, 1e-8, 30,
		  ssr, Rr, tr, &epsh, &cnt);
}
